<template>
  <div class="page-container h-screen pa-2">
    <PageTitle :title="translate('pages.users.index.title')" />

    <div class="flex flex-col justify-between px-8">
      <div>
        <!-- Table filters and custom buttons -->
        <div class="flex align-middle justify-between gap-2 mb-8">
          <v-text-field
            v-model="data.search['email']"
            prepend-inner-icon="mdi-magnify"
            :placeholder="translate('global.email.search.placeholder')"
            @keyup.enter="loadItems"
            class="max-w-[400px] !mt-0"
            bg-color="gray-light"
          ></v-text-field>

          <div class="d-flex justify-end mb-6">
            <ButtonCreate
              v-if="guard.canCreate()"
              :to="{ name: 'users.create', }"
              :label="translate('actions_user.add')"
            />
          </div>
        </div>

        <!-- Data Table -->

        <v-data-table-server
          v-model:items-per-page="data.itemsPerPage"
          :headers="filterVisibleHeaders"
          :items-length="data.totalItems"
          :items="data.serverItems"
          :loading="data.loading"
          @update:options="loadItems"
          :items-per-page-options="data.itemsPerPageOptions"
          fixed-header
        >
          <template v-slot:[`item.actions`]="{ item }">
            <td class="w-full d-block">
              <div class="text-center">
                <v-menu v-if="Object.keys(filterAllowedActionsForUser(item)).length > 0">
                  <template v-slot:activator="{ props }">
                    <div v-bind="props" class="w-full">
                      <v-icon
                        icon="mdi-dots-vertical"
                        class="text-bodyGray cursor-pointer hover:text-tertiary transform transition-color duration-300"
                      ></v-icon>
                    </div>
                  </template>

                  <v-list density="compact" class="!shadow-md">
                    <v-list-item
                      v-for="action in filterAllowedActionsForUser(item) as TableAction[]"
                      :key="action.title"
                      class="hover:cursor-pointer hover:bg-gray-medium"
                      @click="action.process(item)"
                    >
                      <v-list-item-title>
                        {{ action.title }}
                      </v-list-item-title>
                    </v-list-item>
                  </v-list>
                </v-menu>
              </div>
            </td>
          </template>

          <!-- // Empty v-slot:bottom needed to hide default footer inside table -->
          <template v-slot:bottom></template>
        </v-data-table-server>
      </div>

      <Pagination v-if="data.totalItems > 10" :data="data" :loadItems="loadItems"></Pagination>
    </div>
  </div>

</template>

<script lang="ts" setup>
import { ref, computed } from 'vue'
import type { VuetifyPagination, VuetifyDataTableServer, TableAction } from '@/types/tableTypes'
import { ObjectHelper } from '@/helpers/ObjectHelper'
import { useRouter } from 'vue-router'
import { useI18n } from 'vue-i18n'
import { UserGuard } from '@/guards/UserGuard'
import { storeFactory } from '@/main'
import type { User } from '@/types/stores/userStoreTypes'
import { ActivityStatusEnum } from '@/enums/userEnum'
import { watch } from 'vue'

// Components
import PageTitle from '@/components/page/PageTitle.vue'
import Pagination from '@/components/Pagination.vue'
import ButtonCreate from '@/components/button/ButtonCreate.vue'

const guard = new UserGuard()
const { t: translate } = useI18n()
const router = useRouter()
const userStore = storeFactory.userStore
const modalStore = storeFactory.modalStore

const objectHelper = new ObjectHelper()
const userGuard = new UserGuard()

const activateModal = (user: User): void => {
  modalStore.show({
    title: translate('users.activation.modal.title'),
    icon: 'mdi-account-circle',
    body: translate('users.activation.modal.message', {
      email: user.email
    }),
    primary: {
      action: () => {
        userStore.activate(user.id).then(() => {
          user.activity_status = ActivityStatusEnum.ACTIVE

          router.push({ name: 'users.index' })
        })
      },
      type: 'success',
      label: translate('global.yes')
    },
    cancel: {
      action: () => {
      }
    }
  })
}

const deactivateModal = (user: User) => {
  modalStore.show({
    title: translate('users.deactivation.modal.title'),
    icon: 'mdi-account-reactivate-outline',
    body: translate('users.deactivation.modal.message', {
      email: user.email
    }),
    primary: {
      action: () => {
        userStore.deactivate(user.id).then(() => {
          user.activity_status = ActivityStatusEnum.INACTIVE

          router.push({ name: 'users.index' })
        })
      },
      type: 'danger',
      label: translate('global.yes')
    },
    cancel: {
      action: () => {
      }
    }
  })
}

const show = async (user: User) => {
  const authUser = await userStore.searchById(user.id)
  if (!authUser) {
    return
  }

  await userStore.setUser(authUser)
  await router.push({ name: 'users.show', params: { id: user.id } })
}

const edit = async (user: User) => {
  const authUser = await userStore.searchById(user.id)

  if (!authUser) {
    return
  }

  await userStore.setUser(authUser)
  await router.push({ name: 'users.edit', params: { id: user.id } })
}

const data = ref<VuetifyDataTableServer>({
  itemsPerPage: 10,
  headers: computed(() => {
    return [
      {
        title: translate('labels.first_name'),
        align: 'start',
        sortable: false,
        key: 'first_name',
        class: 'text-secondary font-medium'
      },
      {
        title: translate('labels.last_name'),
        align: 'start',
        sortable: false,
        key: 'last_name',
        class: 'text-secondary font-medium'
      },
      {
        title: translate('labels.email'),
        align: 'start',
        sortable: false,
        key: 'email',
        class: 'text-secondary font-medium'
      },
      {
        title: translate('labels.status'),
        align: 'center',
        sortable: false,
        key: 'activity_status'
      },
      {
        title: translate('labels.actions'),
        sortable: false,
        key: 'actions',
        align: 'center'
      }
    ]
  }),
  serverItems: [],
  loading: true,
  totalItems: 0,
  search: {
    email: '',
    language_iso_code: '',
    type: ''
  },
  page: 1,
  actions: computed(() => {
    return {
      show: {
        title: translate('labels.show'),
        icon: 'mdi-account-search',
        process: show,
        isAllowed: userGuard.canShow()
      },
      activate: {
        title: translate('labels.activate'),
        icon: 'mdi-account-circle',
        process: activateModal,
        isAllowed: userGuard.canUpdate()
      },
      deactivate: {
        title: translate('labels.deactivate'),
        icon: 'mdi-account-remove',
        process: deactivateModal,
        isAllowed: userGuard.canDelete()
      },
      edit: {
        title: translate('labels.edit'),
        icon: 'mdi-account-edit',
        process: edit,
        isAllowed: userGuard.canUpdate()
      }
    }
  }),
  itemsPerPageOptions: [
    { title: '10', value: 10 },
    { title: '25', value: 25 },
    { title: '50', value: 50 },
    { title: '100', value: 100 }
  ]
})

const filterVisibleHeaders = computed(() => {
  const headers = data.value.headers

  if (Object.keys(filterAllowedActionsForUser()).length <= 0) {
    headers.pop()
  }

  return headers
})

const actionsMap: { [key: string]: string[] } = {
  [ActivityStatusEnum.ACTIVE]: ['show', 'edit', 'deactivate'],
  [ActivityStatusEnum.INACTIVE]: ['show', 'edit', 'activate'],
  connectedUser: ['edit'],
  default: ['show', 'edit', 'deactivate', 'activate']
}

const filterAllowedActionsForUser = (user: User | null = null): TableAction[] | {} => {
  const activity =
    user && user.id === userStore.getLoggedInUser.id
      ? 'connectedUser'
      : user?.activity_status ?? 'default'

  return objectHelper.filterAllowed(objectHelper.filterByKeys(data.value.actions, actionsMap[activity]))
}

const loadItems = (options: VuetifyPagination) => {
  const searchData: any = {
    user: objectHelper.filterEmpty(data.value.search, true)
  }

  if (options.page) {
    data.value.page = options.page
  }

  searchData.page = options.page ?? data.value.page
  searchData.limit = options.itemsPerPage ?? data.value.itemsPerPage
  data.value.loading = true

  userStore
    .searchUsers(searchData)
    .then(({ items, total }): void => {
      data.value.serverItems = items
      data.value.totalItems = total
      data.value.loading = false
    })
    .catch(() => {
      data.value.loading = false
    })
}

// Watch for changes in data.page and reload items when it changes
watch(
  () => data.value.page,
  () => loadItems({ page: data.value.page } as VuetifyPagination)
)
</script>
